# r_cnn_mobilenet.py
# Vojtěch Golda
from torchvision.models.detection import fasterrcnn_mobilenet_v3_large_320_fpn, FasterRCNN_MobileNet_V3_Large_320_FPN_Weights
from util.model_util import preprocess, get_data_bb, get_model, batch2boxes

from models.model_util import ModelUtil

# 0, 12, 40 
# 60, 2


class RCNNMobileNet(ModelUtil):
    def __init__(self, device, filename="models/r_cnn_mobilenet.pth"):
        self.device = device
        self.model = fasterrcnn_mobilenet_v3_large_320_fpn
        self.weights = FasterRCNN_MobileNet_V3_Large_320_FPN_Weights
        self.target_size = (300, 300)
        self.filename = filename

    def preprocess(*args, **kwargs):
        return preprocess(*args, **kwargs)

    def get_data(*args, **kwargs):
        return get_data_bb(*args, **kwargs)

    def get_model(*args, **kwargs):
        return get_model(*args, **kwargs)

    def batch2boxes(*args, **kwargs):
        return batch2boxes(*args, **kwargs)

